classdef branch < handle
    
    properties
        R
        X
    end
    
    properties (Abstract)
        nx
        ny
        nu % # of [v'_0;v_ref]
        idx % indices of v^2,P,Q,q
    end
    
    methods
        function obj=branch(branches_para)
            R0 = branches_para{:,'R'};
            X0 = branches_para{:,'X'};
            obj.R = R0;
            obj.X = X0;
        end
        
        function out=get_nx(obj)
            out=obj.nx;
        end
        
        function out=get_ny(obj)
            out=obj.ny;
        end
        
        function out=get_nu(obj)
            out=obj.nu;
        end
    end
    
    methods (Abstract)
        add_idx(obj)
        add_idx_u(obj)
    end
    
end